/*
 * This Java source file was generated by the Gradle 'init' task.
 */

package pur.service;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

import java.util.ArrayList;
import java.util.logging.Logger;
import org.junit.jupiter.api.Test;
import spark.Request;
import spark.Response;

public class PurServiceTest {
  Logger log = new App().setupLogger(8000);
  private final PurService service = new PurService(log);
  private final GitService git = new GitService(service, log);
  private ArrayList<ArrayList<String>> names = new ArrayList<ArrayList<String>>(1);

  @Test
  public void testGetContent() {
    String name = "Gander";
    String content = "A gander is a male goose";
    String sha = "e9611923bd9467c1c6e71f4efd110d101c23d2b6";
    Request req1 = mock(Request.class);
    Response res1 = mock(Response.class);
    when(req1.body())
        .thenReturn(
            "{\"name\":\"" + name + "\",\"sha\":\"" + sha + "\",\"content\":\"" + content + "\"}");
    service.postPur(req1, res1);
    Request req2 = mock(Request.class);
    Response res2 = mock(Response.class);
    when(req2.params(":name")).thenReturn(name);
    String serverResponse = git.getContent(req2, res2);
    String comparison =
        "{\"name\":\""
            + name
            + "\",\"commits\":[{\"sha\":\""
            + sha
            + "\",\"content\":\""
            + content
            + "\"}],\"content\":\""
            + content
            + "\"}";
    verify(res2).status(200);
    assertEquals(comparison, serverResponse);
  }

  @Test
  public void testPostAndGet() {
    names = new ArrayList<ArrayList<String>>();
    ArrayList<String> item = new ArrayList<String>(0);
    item.add("gander1");
    item.add("876d1b35edec626dfde5ff865e8bcb30");
    names.add(item);
    for (ArrayList<String> s : names) {
      postPur(s.get(0), s.get(1));
    }
    getAllPurs(names);
  }

  public void postPur(String purName, String sha) {
    Request req = mock(Request.class);
    Response res = mock(Response.class);
    when(req.body()).thenReturn("{\"name\":\"" + purName + "\",\"sha\":\"" + sha + "\"}");
    String serverResponse = service.postPur(req, res);
    verify(res).status(201);
    String comparison =
        "{\"result\":\"" + purName + " successfully added\",\"addedResource\":\"" + purName + "\"}";
    assertEquals(comparison, serverResponse);
  }

  public void getAllPurs(ArrayList<ArrayList<String>> names) {
    Request req = mock(Request.class);
    Response res = mock(Response.class);

    String serverResponse = service.getPurs(req, res);
    verify(res).status(200);

    StringBuilder sb = new StringBuilder("{\"fileNames\":[");
    for (int i = 0; i < names.size(); i++) {
      String name = names.get(i).get(0);
      sb.append(
          "{\"name\":\""
              + name
              + "\",\"commits\":[{\"sha\":\""
              + names.get(i).get(1)
              + "\",\"content\":\"content for "
              + names.get(i).get(1)
              + "\"}],\"type\":\"file"
              + "\",\"content\":\""
              + "\"}");

      if (i != (names.size() - 1)) {
        sb.append(",");
      }
    }
    sb.append("]}");
    assertEquals(sb.toString(), serverResponse);
  }
}
